Dim binNum$(9,3)
InitEANArray()
Global begin$,trennung$

Function InitEANArray()
	Local z,x
	z=0
	binNum(0,z)="0001101"
	binNum(1,z)="0011001"
	binNum(2,z)="0010011"
	binNum(3,z)="0111101"
	binNum(4,z)="0100011"
	binNum(5,z)="0110001"
	binNum(6,z)="0101111"
	binNum(7,z)="0111011"
	binNum(8,z)="0110111"
	binNum(9,z)="0001011"
	begin="x101x"
	trennung="x01010x"
	For z=0 To 9
		For x=1 To 7
			binNum(z,2)=binNum(z,2)+(1-Int(Mid(binNum(z,0),x,1))) ;1 und 0 ersetzten
		Next
		For x=1 To 7
			binNum(z,1)=binNum(z,1)+Mid(binNum(z,2),8-x,1)
		Next
	Next
	z=3
	binNum(0,z)="000000
	binNum(1,z)="001011
	binNum(2,z)="001101
	binNum(3,z)="001110
	binNum(4,z)="010011
	binNum(5,z)="011001
	binNum(6,z)="011100
	binNum(7,z)="010101
	binNum(8,z)="010110
	binNum(9,z)="011010
	
End Function

Function EAN8Barcode%(code$,imgHeight=50,shortBarHeight=45,maskImg=0)
	Local z,zeichenSatz,codeString$,ziffer
	code=CheckBarCodeInput(code,8)
	If code="" Then Return 0
	codeString=GetEANCodeString$(code$,8)
	Return CreateCodeImage(codeString,imgHeight,shortBarHeight,maskImg)
End Function

Function EAN13Barcode%(code$,imgHeight=50,shortBarHeight=45,maskImg=0)
	Local z,zeichenSatz,codeString$,ziffer,thirteen
	code=CheckBarCodeInput(code,13)
	If code="" Then Return 0
	Return CreateCodeImage(codeString,imgHeight,shortBarHeight,maskImg)
End Function

Function GetEANCodeString$(code$,ean)
	Local z,ziffer,codeString$,zeichensatz,zeichensatz2,thirteen$
	Select ean
		Case 8
			zeichensatz=0  ; A
			zeichensatz2=2 ; C
		Case 13
			zeichensatz2=2 ; C
			thirteen=binNum(Int(Left(code,1)),3)
			code=Right(code,12)
		Default 
			Return
	End Select
	
	If Not Len(code)/2.=Floor(Len(code)/2.) Then Return
	For z=1 To Len(code)
		ziffer=Int(Mid(code,z,1))
		If Not thirteen="" Then
			zeichensatz=Mid(thirteen,z,1)
		EndIf
		codeString=codeString+binNum(ziffer,zeichensatz)
		If z=Len(code)/2. Then 
			codeString=codeString+trennung
			zeichensatz=zeichensatz2
			thirteen=""
		EndIf
	Next
	codeString=begin+codeString+begin
	Return codeString
End Function

Function CheckBarCodeInput$(code$,sLen)
	Local z
	If Len(code)>sLen Then Return ""
	For z=1 To Len(code)
		If Not Mid(code,z,1)=Int(Mid(code,z,1)) Then Return ""
	Next
	If Len(code)<sLen Then
		For z=Len(code) To sLen-1
			code="0"+code
		Next
	EndIf
	Return code
End Function
Function GetCodeImageWidth%(BinCode$)
	Local z,count
	For z=1 To Len(BinCode)
		If Not Mid(BinCode,z,1)="x" Then count=count+1
	Next
	Return count+1
End Function
Function CreateCodeImage%(BinCode$,imgHeight,shortBarHeight,masked=0)
	Local short=1,x,y,currentHeight,currentColor
	Local imgWidth=GetCodeImageWidth(BinCode$)
	Local codeImage=CreateImage(imgWidth,imgHeight)
	SetBuffer ImageBuffer(codeImage)
	Color 255,255,255
	If Not masked=0 Then Color 255,0,0
	Rect 0,0,imgWidth,imgHeight,1
	Local xMinus
	For x=1 To Len(BinCode)
		If Mid(BinCode,x,1)="x" Then 
			short=1-short
			x=x+1
			xMinus=xMinus+1
		EndIf	
			
		If short=1 Then
			currentHeight=shortBarHeight
		Else
			currentHeight=imgHeight
		EndIf
		If Int(Mid(BinCode,x,1))=0 Then
			Color 255,255,255
		Else
			Color 0,0,0
		EndIf
		Rect x-xMinus,y,1,currentHeight,1
	Next
	SetBuffer BackBuffer()
	If Not masked=0 Then MaskImage codeImage,255,0,0
	Return codeImage
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D